package br.com.arquitetodigital.ems.action;

import br.com.arquitetodigital.ems.model.*;

import java.util.ArrayList;
import java.util.List;

import javax.faces.context.FacesContext;
import javax.persistence.EntityManager;
import javax.persistence.OrderBy;
import javax.servlet.ServletContext;

import org.jboss.seam.ScopeType;
import org.jboss.seam.annotations.Factory;
import org.jboss.seam.annotations.In;
import org.jboss.seam.annotations.Logger;
import org.jboss.seam.annotations.Name;
import org.jboss.seam.annotations.Transactional;
import org.jboss.seam.annotations.datamodel.DataModel;
import org.jboss.seam.framework.EntityHome;
import org.jboss.seam.log.Log;

@Name("countryHome")
public class CountryHome extends EntityHome<Country> {

	@Logger private Log log;
	

	@In
	private EntityManager entityManager;
	
	@DataModel(scope = ScopeType.PAGE)
	private List<Country> factoryCountryList;

	@Factory("factoryCountryList")
	public void retrieveAllCountries() {
		log.info("Factory for factoryCountryList called. Retrieving all Countrys...");
		factoryCountryList = (List<Country>) entityManager.createQuery("select c from Country c order by lower(c.nameEn)").getResultList();
	}

	public void setCountryId(Long id) {
		setId(id);
	}

	public Long getCountryId() {
		return (Long) getId();
	}


	public void create() {
		
	}
	
	@Override
	protected Country createInstance() {
		Country country = new Country();
		return country;
	}

	public void wire() {
		if (this.getInstance() == null) {
			this.setInstance(new Country());
		}
	}

	public boolean isWired() {
		return true;
	}

	public Country getDefinedInstance() {
		return isIdDefined() ? getInstance() : null;
	}

	@Override
	public void clearInstance() {
		super.clearInstance();
	}
	
	@Transactional
	public String save() {
		//log.info("tr is active no inicio" + entityManager.getTransaction().isActive());
		//UserTransaction userTransaction  =  Transaction.instance();

		//entityManager.joinTransaction();
		
		log.info("entrei na save");
		if (entityManager.getFlushMode() == null) {
			log.info("== Flush Mode -  null"  );
		} else {
			log.info("== Flush Mode - " + entityManager.getFlushMode());
		}


			entityManager.persist(this.instance);
			log.info("==================================================");
			log.info("Fazendo Flush entidade principal - " + this.instance.toString()  );
			log.info("== Classe da instancia - " + this.instance.getClass().toString());
			log.info("==================================================");
			
			
			
			//log.info("transaction. class: " + userTransaction.getClass());

			//log.info("transaction.toString: " + userTransaction.toString());

			//log.info("tr is active antes flush" + entityManager.getTransaction().isActive());
			entityManager.flush();
			//log.info("tr is active depois flush" + entityManager.getTransaction().isActive());
			
//			try {
//				userTransaction.commit();
//			} catch (SecurityException e) {
//				// TODO Auto-generated catch block
//				e.printStackTrace();
//			} catch (IllegalStateException e) {
//				// TODO Auto-generated catch block
//				e.printStackTrace();
//			} catch (RollbackException e) {
//				// TODO Auto-generated catch block
//				e.printStackTrace();
//			} catch (HeuristicMixedException e) {
//				// TODO Auto-generated catch block
//				e.printStackTrace();
//			} catch (HeuristicRollbackException e) {
//				// TODO Auto-generated catch block
//				e.printStackTrace();
//			} catch (SystemException e) {
//				// TODO Auto-generated catch block
//				e.printStackTrace();
//			}
			
			//log.info("tr is active" + entityManager.getTransaction().isActive());
			//if(entityManager.getTransaction().isActive()){
			//	entityManager.getTransaction().commit(); 
			//	entityManager.getTransaction().begin(); 
			//}
			
			
			
			return "home";
			//this.redirect(((ServletContext)FacesContext.getCurrentInstance().getExternalContext().getContext()).getContextPath() + "/home.seam");
	}
		
}	


