package br.com.arquitetodigital.ems.action;

import br.com.arquitetodigital.ems.model.*;

import org.jboss.seam.ScopeType;
import org.jboss.seam.annotations.In;
import org.jboss.seam.annotations.Logger;
import org.jboss.seam.annotations.Name;
import org.jboss.seam.annotations.Scope;
import org.jboss.seam.faces.FacesMessages;
import org.jboss.seam.framework.EntityQuery;
import org.jboss.seam.log.Log;

import java.util.Arrays;

@Name("countryList")
@Scope(ScopeType.CONVERSATION)
public class CountryList extends EntityQuery<Country> {

	@Logger Log log;
	@In FacesMessages facesMessages;	
	
	private static final String EJBQL = "select country from Country country";

	private static final String[] RESTRICTIONS = {
			"lower(country.descriptiveTextEn) like concat('%',lower(#{countryList.country.descriptiveTextEn}),'%')",
			"lower(country.descriptiveTextEs) like concat('%',lower(#{countryList.country.descriptiveTextEs}),'%')",
			"lower(country.descriptiveTextFr) like concat('%',lower(#{countryList.country.descriptiveTextFr}),'%')",
			"lower(country.descriptiveTextPt) like concat('%',lower(#{countryList.country.descriptiveTextPt}),'%')",
			"lower(country.mnemonic) like concat('%',lower(#{countryList.country.mnemonic}),'%')",
			"lower(country.nameEn) like concat('%',lower(#{countryList.country.nameEn}),'%')",
			"lower(country.nameEs) like concat('%',lower(#{countryList.country.nameEs}),'%')",
			"lower(country.nameFr) like concat('%',lower(#{countryList.country.nameFr}),'%')",
			"lower(country.namePt) like concat('%',lower(#{countryList.country.namePt}),'%')",
			"lower(country.nationalityNameEn) like concat('%',lower(#{countryList.country.nationalityNameEn}),'%')",
			"lower(country.nationalityNameEs) like concat('%',lower(#{countryList.country.nationalityNameEs}),'%')",
			"lower(country.nationalityNameFr) like concat('%',lower(#{countryList.country.nationalityNameFr}),'%')",
			"lower(country.nationalityNamePt) like concat('%',lower(#{countryList.country.nationalityNamePt}),'%')",
			"lower(country.spokenLanguageEn) like concat('%',lower(#{countryList.country.spokenLanguageEn}),'%')",
			"lower(country.spokenLanguageEs) like concat('%',lower(#{countryList.country.spokenLanguageEs}),'%')",
			"lower(country.spokenLanguageFr) like concat('%',lower(#{countryList.country.spokenLanguageFr}),'%')",
			"lower(country.spokenLanguagePt) like concat('%',lower(#{countryList.country.spokenLanguagePt}),'%')",
		};

	private Country country = new Country();

	public CountryList() {
		setEjbql(EJBQL);
		setRestrictionExpressionStrings(Arrays.asList(RESTRICTIONS));
		setMaxResults(25);
		setOrder("country.nameEn");
		
	}


	public void reset() {
		log.info("entrei no reset");
		//faz reset de todos os objetos locais: Entity e listas associadas
		this.country = new Country();
		// faz o reset do resto da entity query
		//super.reset();
	}	
	
	public Country getCountry() {
		return country;
	}
}
